<?php
/**
 # JV Framework
 # @version		1.5.x
 # ------------------------------------------------------------------------
 # author    Open Source Code Solutions Co
 # copyright Copyright (C) 2011 joomlavi.com. All Rights Reserved.
 # @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL or later.
 # Websites: http://www.joomlavi.com
 # Technical Support:  http://www.joomlavi.com/my-tickets.html
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' );	

class JVFrameworkExtensionMobile extends JVFrameworkExtension{

	public function beforeRender(){
		$head = JFactory::getDocument();
		if(!$this['browser']->isMobile() || $this['browser']->isTablet()) return;
		// Theme path
		$basePath  = current($this['path']->getPath('basetheme'));
		$themePath = JPATH_THEMES.'/'.JFactory::getApplication()->getTemplate();
		
		if($this['option']->get('mobile.allmobile.enable')){
			// Mobile path
			$this['path']->addPath($basePath.'/layouts/mobiles', 'theme');			
			$this['path']->addPath($themePath.'/layouts/mobiles', 'theme');
			$this['path']->addPath($basePath.'/layouts/mobiles', 'layouts');
			$this['path']->addPath($themePath.'/layouts/mobiles', 'layouts');
			$this['path']->addPath($basePath.'/layouts/mobiles/html', 'override');
			$this['path']->addPath($themePath.'/layouts/mobiles/html', 'override');

			if($this['option']->get('mobile.iphone.enable')){
				if($this['browser']->is(Browser::BROWSER_IPHONE)){
					// Mobile path
					$this['path']->addPath($themePath.'/layouts/mobiles/iphone', 'theme');
					$this['path']->addPath($themePath.'/layouts/mobiles/iphone', 'layouts');
					$this['path']->addPath($themePath.'/layouts/mobiles/iphone/html', 'override');
				}
			}
			
			if($this['option']->get('mobile.android.enable')){
				if($this['browser']->is(Browser::BROWSER_ANDROID)){
					// Mobile path
					$this['path']->addPath($themePath.'/layouts/mobiles/android', 'theme');
					$this['path']->addPath($themePath.'/layouts/mobiles/android', 'layouts');
					$this['path']->addPath($themePath.'/layouts/mobiles/android/html', 'override');
				}
			}
		}
		
		// Position Alias
		$positions = $this['option']->get('mobile.allmobile.positions');		
		if(is_object($positions)){
			foreach ($positions as $position => $option) {
				if($option->alias){
					$this['position']->alias($position, $option->alias);
					$this['option']->set('position.'.$option->alias, $option);
				}else{
					$this['option']->set('position.'.$position, $option);
				}				
			}			
		}		
		
	}
}