
<?php
/**
 * @package		Joomla.Site
 * @subpackage	com_content
 * @copyright	Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights reserved.
 * @license		GNU General Public License version 2 or later; see LICENSE.txt
 */

// no direct access
defined('_JEXEC') or die;

JHtml::addIncludePath(JPATH_COMPONENT.'/helpers');

// If the page class is defined, add to class as suffix.
// It will be a separate class if the user starts it with a space
?>
<div class="blog-featured blog<?php echo $this->pageclass_sfx;?>">

<!-- Page Heading -->
<?php if ( $this->params->get('show_page_heading')!=0) : ?>
    <h1 class="page_heading">
    	<?php echo $this->escape($this->params->get('page_heading')); ?>
    </h1>
<?php endif; ?>

<!-- Show Leading -->
<?php $leadingcount=0 ; ?>

<?php if (!empty($this->lead_items)) : ?>
    <div class="items-leading">
    <?php foreach ($this->lead_items as &$item) : ?>
        <div class="leading-<?php echo $leadingcount; ?><?php echo $item->state == 0 ? ' system-unpublished' : null; ?> in_cols clearfix">
            <?php
            $this->item = &$item;
            echo $this->loadTemplate('item');
            ?>
        </div>
    	<?php $leadingcount++;?>
    <?php endforeach; ?>
    </div>
<?php endif; ?>

<!-- Show Intro -->
<?php
	$introcount=(count($this->intro_items));
	$counter=0;
	$grid = 'span'.round(12/$this->columns);
?>

<?php if (!empty($this->intro_items)) : ?>
	<?php foreach ($this->intro_items as $key => &$item) : ?>

	<?php
		$key= ($key-$leadingcount)+1;
		$rowcount=( ((int)$key-1) %	(int) $this->columns) +1;
		$row = $counter / $this->columns ;
		if ($rowcount==1) :
    ?>
        <div class="items-row row-fluid columns col-<?php echo (int) $this->columns;?>">
			<?php endif; ?>
            <div class="item <?php echo $grid;?><?php echo $item->state == 0 ? ' system-unpublished"' : null; ?>">
                <div class="in_cols clearfix">
                <?php
                    $this->item = &$item;
                    echo $this->loadTemplate('item');
                ?>
                </div>
            </div>
            <?php $counter++; ?>
            <?php if (($rowcount == $this->columns) or ($counter ==$introcount)): ?>
            <span class="row-separator"></span>
        </div>
		<?php endif; ?>
	<?php endforeach; ?>
<?php endif; ?>

<!-- Links -->
<?php if (!empty($this->link_items)) : ?>
    <div class="items-more">
    	<?php echo $this->loadTemplate('links'); ?>
    </div>
<?php endif; ?>

<!-- Pagination -->
<?php if ($this->params->def('show_pagination', 2) == 1  || ($this->params->get('show_pagination') == 2 && $this->pagination->get('pages.total') > 1)) : ?>
    <div class="pagination">
		<?php if ($this->params->def('show_pagination_results', 1)) : ?>
            <p class="counter">
            	<?php echo $this->pagination->getPagesCounter(); ?>
            </p>
        <?php  endif; ?>
        <?php echo $this->pagination->getPagesLinks(); ?>
    </div>
<?php endif; ?>
</div>