<?php
/**
 # JV Framework
 # @version		1.5.x
 # ------------------------------------------------------------------------
 # author    Open Source Code Solutions Co
 # copyright Copyright (C) 2011 joomlavi.com. All Rights Reserved.
 # @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL or later.
 # Websites: http://www.joomlavi.com
 # Technical Support:  http://www.joomlavi.com/my-tickets.html
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' );	

class JVFrameworkExtensionLayout extends JVFrameworkExtension{

	public function beforeRender(){
		$params = $this['option'];
		
		// Layout width
		$width = json_decode($params->get('layouts.middle'), true);		
		list($sidebar_a, $content, $sidebar_b) = $width[3];
		
		//
		$params->set('template.sidebar-a.class', 'span'.$sidebar_a);
		$params->set('template.sidebar-b.class', 'span'.$sidebar_b);
		$params->set('template.content.class'  , 'span'.$content);
		
		$hasSidebarA = $this['block']->count('left');
		$hasSidebarB = $this['block']->count('right');
		$hasSidebars = $hasSidebarA + $hasSidebarB;
		
		$templates = JFactory::getApplication()->getTemplate(true);
		$name = md5($templates->template.$templates->id.$templates->home);
		
		// Layout type
		$layout = JFactory::getApplication()->input->get('l');
		if($layout || (isset($_COOKIE['jvlayout']) && isset($_COOKIE['jvlayout'][$name]) && isset($_COOKIE['jvlayout'][$name]['type']))){	
			if($layout){
				setcookie("jvlayout[{$name}][type]", $layout);
			}else {
				$layout = $_COOKIE['jvlayout'][$name]['type'];
			}	
			if($layout == 'reset'){
				unset($_COOKIE['jvlayout'][$name]['type']);
				$layout = '';
			}		
		}
		if(!$layout){
			$layout = $params->get('layout.type', 'sb-c-sb');		
			setcookie("jvlayout[{$name}][type]", $layout);
		}
		
		switch ($layout){
		
			case 'sb-c' :
				// Unload sidebar
				$this['template']->unLoad('sidebar-b');
				
				$push 	  = $sidebar_a;	
				$content += $sidebar_b;
				
				// Set style
				if(!$hasSidebarA){
					$content += $sidebar_a;
					$push -= $sidebar_a;
				}				
				
				$params->set('template.sidebar-a.class', "span{$sidebar_a} pull{$content}");				
				if($push){					
					$params->set('template.content.class'  , "span{$content} push{$push}");
				}else{
					$params->set('template.content.class'  , "span{$content}");
				}
				
				break;
		
			case 'c-sb' :
				// Unload sidebar			
				$this['template']->unLoad('sidebar-a');
		
				// Set style
				if(!$hasSidebarB){
					$content += $sidebar_b;
				}
		
				$params->set('template.content.class'  , 'span'.($content+$sidebar_b));
				break;
		
			case 'sb-c-sb' :
				
				$push = $sidebar_a;
				
				// Set style
				if(!$hasSidebarA){
					$content += $sidebar_a;
					$push -= $sidebar_a;
				}
				
				if(!$hasSidebarB){
					$content += $sidebar_b;				
				}
				
				$params->set('template.sidebar-a.class', "span{$sidebar_a} pull{$content}");
				
				if($push)
					$params->set('template.content.class'  , "span{$content} push{$push}");
				else
					$params->set('template.content.class'  , "span{$content}");
				
				break;
		
			case 'c-sb-sb' :				
				// Set style
				if(!$hasSidebarA){
					$content += $sidebar_a;
				}
		
				if(!$hasSidebarB){
					$content += $sidebar_b;
				}
		
				$params->set('template.content.class'  , 'span'.($content));
		
				break;
		
			case 'sb-sb-c' :
				$push = $sidebar_a + $sidebar_b;				
				
				// Set style
				if(!$hasSidebarA){
					$content += $sidebar_a;
					$push -= $sidebar_a;
				}
		
				if(!$hasSidebarB){
					$content += $sidebar_b;
					$push -= $sidebar_b;
				}
				
				$params->set('template.sidebar-a.class', "span{$sidebar_a} pull{$content}");
				$params->set('template.sidebar-b.class', "span{$sidebar_b} pull{$content}");
				$params->set('template.content.class'  , "span{$content} push{$push}");
		
				break;		
		}
		
		
		
		$layouts = $params->get('layouts.block');
		if(!$layouts){
			return false;
		}
		
		foreach ($layouts as $key => $layout) {
			if(is_object($layout)){
				if(isset($layout->positions)){
					$positions = $layout->positions;
					if(is_object($positions)){
						foreach ($positions as $position => $option) {
							if($option->alias){
								$this['position']->alias($position, $option->alias);
								$this['option']->set('position.'.$option->alias, $option);
							}else{
								$this['option']->set('position.'.$position, $option);
							}
						}
					}
					unset($layout->positions);
				}				
				
				foreach ($layout as $k => $v){
					$this['option']->set('block.'.$key.'.'.$k, $v);
				}
			}
			
		}
	}
}