<?php
/**
 # JV Framework
 # @version		1.5.x
 # ------------------------------------------------------------------------
 # author    Open Source Code Solutions Co
 # copyright Copyright (C) 2011 joomlavi.com. All Rights Reserved.
 # @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL or later.
 # Websites: http://www.joomlavi.com
 # Technical Support:  http://www.joomlavi.com/my-tickets.html
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' );	

class JVFrameworkExtensionLogo extends JVFrameworkExtension{
		
	public function beforeRender(){		
		$params = $this['option'];		
		$this['position']->register('logo', $params->get('extension.logo.position', 'logo'));
		
		$this['asset']->addInlineStyle(
			$this['asset']->buildCss('.logo img, a#logo', array(
				'width' 	=> $params->get('extension.logo.width'),
				'height' 	=> $params->get('extension.logo.height'),
				'padding' 	=> $params->get('extension.logo.padding')
			))
		);
	}
	
	public function html($options){
		ob_start();
		if ($this['option']->get('extension.logo.type', 'text') == 'text'):?> 
		<div class="position extension logo">
			<div class="logo">
				<a id="logo" href="<?php echo JURI::base(true); ?>" title="<?php echo $this['option']->get('sitename'); ?>">
					<span class="text"><?php echo $this['option']->get('extension.logo.text', $this['option']->get('sitename')); ?></span>
					<span class="slogan"><?php echo $this['option']->get('extension.logo.slogan'); ?></span>
				</a>
			</div>
		</div>
		<?php else : ?>
		<div class="position extension logo">
			<div class="logo">
				
				<?php if($this['option']->get('extension.logo.image')) :?>
				<a id="logo" class="sitelogo" href="<?php echo JURI::base(true); ?>" title="<?php echo $this['option']->get('sitename'); ?>">
					<img src="<?php echo JRoute::_($this['option']->get('extension.logo.image')); ?>" alt="<?php echo $this['option']->get('sitename'); ?>"/>
				<?php else:?>
				<a id="logo" class="sitelogo noimage" href="<?php echo JURI::base(true); ?>" title="<?php echo $this['option']->get('sitename'); ?>">
				<?php endif;?>
				</a>
			</div>
		</div>
		<?php
		endif;
		
		return ob_get_clean();
	
	}
	
}

