<?php
/**
 # com_jvframework - JV Framework
 # @version		1.5.x
 # ------------------------------------------------------------------------
 # author    Open Source Code Solutions Co
 # copyright Copyright (C) 2011 joomlavi.com. All Rights Reserved.
 # @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL or later.
 # Websites: http://www.joomlavi.com
 # Technical Support:  http://www.joomlavi.com/my-tickets.html
 */

// No direct access to this file
defined ( '_JEXEC' ) or die ( 'Restricted access' );
require_once dirname ( dirname ( __FILE__ ) ) . '/menuitem.php';

class FlexMenuItemGroup extends FlexMenuItem {
	
	public function begin() {
		if ($this->getParam ( 'fxmenu_width' ) != '') {
			JFactory::getDocument()->addStyleDeclaration( "#fx-item{$this->item->id}{ width: " . $this->getParam ( 'fxmenu_width' ) . ";}" );
		}
		if ($this->item->column && $this->item->column > 1) {
			if ($this->index == 1) {
				$html [] = $this->beginRow ( 'fx' );
			}
			$html [] = $this->beginCol ( $this->item->column, $this->getClass () );
	
		} else
			$html [] = "<li id='fx-item{$this->item->id}' class='fx-item" . ($this->index) . " group " . $this->getClass () . "'>";
	
		return implode ( '', $html );
	}
	
	function getLink() {
		if(isset($this->item->oldtype) && $this->item->oldtype == 'url'){
			return $this->item->link;
		}
		$flink = $this->item->link;
		
		$router = JSite::getRouter ();
		if ($router->getMode () == JROUTER_MODE_SEF) {
			$flink = 'index.php?Itemid=' . $this->item->id;
		} else {
			$flink .= '&Itemid=' . $this->item->id;
		}
		
		return parent::getLink ( $flink );
	}
	
	function getHtml() {

        $html = $class = $attributes = array ();
		if($this->item->params->get ( 'fxmenu_titlelink', 0 )){
			$attributes [] = "href='{$this->getLink()}'";
		}else{
			$attributes [] = "href='javascript:void(0)'";
		}

        $this->item->title = htmlspecialchars ( $this->item->title );
        if ($this->item->params->get ( 'menu-anchor_css', '' )) {
            $class [] = htmlspecialchars ( $this->item->params->get ('menu-anchor_css') );
        }

        if ($this->item->params->get ( 'menu_image' )  && $this->item->params->get ( 'menu_image' ) != -1){
            if($this->item->params->get ( 'menu_image_type', 'img' ) == 'img'){
                $class [] = "iconImage";
            }else{
                $class [] = "iconBackground";
            }
        }

        if($class){
            $attributes [] = 'class="' . implode(' ',$class) . '" ';
        }
		
		if ($this->item->params->get ( 'menu-anchor_title', '' )) {
			$attributes [] = 'title="' . htmlspecialchars ( $this->item->params->get ( 'menu-anchor_title' ) ) . '" ';
		}
		
		if ($this->item->browserNav == 1) {
			$attributes [] = 'target="_blank"';
		}
		
		if ($this->item->browserNav == 2) {
			$attributes [] = "onclick=\"window.open(this.href,'targetWindow','toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes');return false;\"";
		}
		
		if($this->item->params->get ( 'fxmenu_title', 1 )){		
			$html [] = "<div class='group-title'>";			
			$html [] = "<a " . implode ( ' ', $attributes ) . ">";
			$html [] = $this->getTitle();
			$html [] = "</a>";
			$html [] = "</div>";
		}
		
		return implode ( '', $html );
	}
	
	public function getClass() {
		$class = array ();
		$class [] = 'level'.$this->level;
		$class [] = $this->getParam ( 'fxmenu_group' ) ? 'group' : '';
		$class [] = $this->haschild ? 'hasChild' : '';
		$class [] = $this->getParam ( 'fxmenu_column' ) > 1 ? 'cols' . $this->getParam ( 'fxmenu_column' ) : '';
		$class [] = 'fx' . $this->getParam ( 'fxmenu_submenu', 'submenu' );
		if($this->active){
			$class [] = 'active';
		}
	
		return implode ( ' ', $class );
	}
	
	public function beginSub() {
		$html = array ();
		if ($this->getParam ( 'fxmenu_column' ) > 1 ) {
			$html [] = '<div class="group-content">';
		}else {
			$html [] = '<ul class="group-content">';
		}
		
	
		return implode ( '', $html );
	}
	
	public function endSub() {
		$html = array ();	
		if ($this->getParam ( 'fxmenu_column' ) > 1 ) {
			$html [] = '</div>';
		}else{
			$html [] = '</ul>';
		}
		
		return implode ( '', $html );
	}
}