<?php
/**
 # JV Framework
 # @version		1.5.x
 # ------------------------------------------------------------------------
 # author    Open Source Code Solutions Co
 # copyright Copyright (C) 2011 joomlavi.com. All Rights Reserved.
 # @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL or later.
 # Websites: http://www.joomlavi.com
 # Technical Support:  http://www.joomlavi.com/my-tickets.html
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' );

class JVFrameworkHelperPath extends JVFrameworkHelper {
	protected static $paths = array ();
	protected $_name = 'path';

	public function addPath($newpath = array(), $type = 'layouts') {
		if (! isset ( self::$paths [$type] )) {
			self::$paths [$type] = array ();
		}

		$paths = & self::$paths [$type];
		settype ( $newpath, 'array' );

		foreach ( $newpath as $path ) {
			if (! in_array ( $path, $paths ) && $path) {
				array_unshift ( $paths, trim ( $path ) );
			}
		}

		return $paths;
	}

	public function findPath($file, $type = 'layouts') {
		if (strpos($file, '::')){
			list ( $type, $file ) = explode ( '::', $file );			
		}
		if (! isset ( self::$paths [$type] )) {
			self::$paths [$type] = array ();
		}
		
		$paths = & self::$paths [$type];

		return JPath::find ( $paths, $file );
	}
	
	public function write($file, $content) {
		if (strpos($file, '::')){
			list ( $type, $file ) = explode ( '::', $file );
		}		
		$path = current($this->getPath($type));
		
		if($path){
			$path = $path.'/'.$file;
			JFile::write($path, $content);
			
			return $path;
		}
		
		return false;
	}
	
	public function read($file) {	
		$path = $this->findPath($file);
		
		if($path)
			return JFile::read($path);
		
		return false;
	}
	
	public function remove($file) {
		$path = $this->findPath($file);
	
		if($path)
			return JFile::delete($path);
	
		return false;
	}
	
	public function getPath($type) {
		return $this->addPath('', $type);
	}
	
	public function url($file, $type = 'layouts') {
		$path = $this->findPath($file, $type);
		if(!$path){
			return false;
		}
		
		return $this->toURL($path);
	}
	
	public function toURL($path) {
		$path = str_replace(JPATH_ROOT.DIRECTORY_SEPARATOR, '', str_replace('/', DIRECTORY_SEPARATOR, $path));
		$url = str_replace(DIRECTORY_SEPARATOR, '/', $path);
		
		return JURI::root(true) .'/'. $url;
	}
	
	public function getUrl($type) {
		return $this->toURL($this->getPath($type));
	}

}