<?php
/**
 # JV Framework
 # @version		1.5.x
 # ------------------------------------------------------------------------
 # author    Open Source Code Solutions Co
 # copyright Copyright (C) 2011 joomlavi.com. All Rights Reserved.
 # @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL or later.
 # Websites: http://www.joomlavi.com
 # Technical Support:  http://www.joomlavi.com/my-tickets.html
 */
defined ( '_JEXEC' ) or die ( 'Restricted access' );
JVFrameworkLoader::import ( 'joomlib.application.module.helper' );
JVFrameworkLoader::import ( 'helpers.template' );

class JVFrameworkHelperPosition extends JVFrameworkHelperTemplate {
	protected $_name = 'position';
	protected $_extension = array ();
	protected static $modules = array ();
	protected static $positions = array ();
	
	public function render($position) {
		$options = array();
		if (strpos($position, '::')){
			list ( $position, $options ) = explode ( '::', $position );			
			$options = json_decode($options, true);			
		}
		
		if (strpos($position, '.')){
			list ( $position, $options['style'] ) = explode ( '.', $position );	
		}

		$position = isset ( $this->_alias [$position] )   ? $this->_alias [$position]   : $position;
		
		if (isset ( $this->_unloads [$position] )) {
			return false;
		}			
		
		$extensions = isset ( $this->_extension [$position] ) ? $this->_extension [$position] : array ();

		// Merge Position Options
		foreach ($this['option']->get('position.'.$position, array()) as $key => $val){
			$options[$key] = $val;
		}
		
		return $this ['template']->render ( 'position', compact ( 'position', 'options', 'extensions' ) );
	}
	
	public function load($position) {
		if (! isset ( self::$modules [$position] )) {
			$renderer = JFactory::getDocument ()->loadRenderer ( 'module' );
			self::$modules [$position] = JModuleHelper::getModules ( $position );
			foreach ( self::$modules [$position] as $module ) {
				$module->parameter = new JRegistry ( $module->params );
				$module->content   = $renderer->render ( $module, array('style' => 'none') );
				
				$this['event']->fireEvent('onRenderModule', array(&$module, &$module->parameter));
			}
		}
		
		return self::$modules [$position];
	}
	
	public function register($name, $position, $options = array()) {
		if (! $position) {
			trigger_error ( 'Please enter position name !' );
		}
		$this->_extension [$position] [$name] [] = $options;
	}
	
	/**
	 *
	 * @package Joomla.Platform
	 * @subpackage Document
	 *            
	 * @copyright Copyright (C) 2005 - 2012 Open Source Matters, Inc. All rights
	 *            reserved.
	 * @license GNU General Public License version 2 or later; see LICENSE
	 */
	/**
	 * Count the modules based on the given condition
	 *
	 * @param string $condition
	 *        	The condition to use
	 *        	
	 * @return integer Number of modules found
	 *        
	 * @since 11.1
	 */
	public function count($condition) {
		if(!class_exists('JDocumentHTML')){
			return false;
		}
				
		$operators = '(\+|\-|\*|\/|==|\!=|\<\>|\<|\>|\<=|\>=|and|or|xor)';
		$words = preg_split ( '# ' . $operators . ' #', $condition, null, PREG_SPLIT_DELIM_CAPTURE );
		for($i = 0, $n = count ( $words ); $i < $n; $i += 2) {
			// odd parts (modules)
			$name = strtolower ( $words [$i] );
			$name = isset ( $this->_alias [$name] ) ? $this->_alias [$name] : $name;
			
			$words [$i] = ((isset ( JDocumentHTML::$_buffer ['modules'] [$name] )) && (JDocumentHTML::$_buffer ['modules'] [$name] === false)) ? 0 : count ( JModuleHelper::getModules ( $name ) );
			
			if (isset ( $this->_extension [$name] )) {
				$words [$i] = 1;
			}
		}
		
		$str = 'return ' . implode ( ' ', $words ) . ';';
		
		return eval ( $str );
	}
}
?>