<?php
/**
 # plg_system_jvgallery - JV Gallery
 # @version		1.6.x
 # ------------------------------------------------------------------------
 # author    Open Source Code Solutions Co
 # copyright Copyright (C) 2011 joomlavi.com. All Rights Reserved.
 # @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL or later.
 # Websites: http://www.joomlavi.com
 # Technical Support:  http://www.joomlavi.com/my-tickets.html
-------------------------------------------------------------------------*/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.menu');
jimport( 'joomla.plugin.plugin' );
jimport('joomla.filesystem.file');

class plgSystemJVGallery extends JPlugin
{
    protected $abort = array();
	/**
	 * Constructor
	 *
	 * For php4 compatability we must not use the __constructor as a constructor for plugins
	 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
	 * This causes problems with cross-referencing necessary for the observer design pattern.
	 *
	 * @access	protected
	 * @param	object	$subject The object to observe
	 * @param 	array   $config  An array that holds the plugin configuration
	 * @since	1.0
	 */
	public function plgSystemJVGallery (& $subject, $config){	
		parent :: __construct($subject, $config);
	}

	public function onAfterRoute(){
		if(JRequest::getBool('jvgallery')){
			die($this->html());
		}
		 
		if(JRequest::getBool('connector')){
			die($this->connector());
		}
	}
	
	public function onContentPrepare($context, &$article, &$params, $page = 0)
	{
		// expression to search for
		$regex = '#\[JVGALLERY\](.*?)\[\/JVGALLERY\]#i';
		preg_match_all( $regex, $article->text, $matche );
		
		if(count($matche[0])){
			foreach($matche[0] as $index => $matc){
				$replace = preg_quote($matc, '/');
				if(!in_array($matc,$this->abort)){
					$data = new JRegistry($matche[1][$index]);
					$article->text = preg_replace("/$replace/", $this->render($data), $article->text);
				}
			}
		}
		
	}
    
    public function resize($img, $option){
    	if(!class_exists('PhpThumbFactory') && !class_exists('GdThumb')){
    		require_once dirname(__FILE__).'/jvgallery/classes/ThumbLib.inc.php';
    	}
    
    	$replace = JURI::base(true).'/';
    	if(strpos($img, $replace) === 0){
    		$img = substr($img, strlen($replace));
    	}
    
    	// Fileinfo
    	$imgPath = realpath($img);
    	$info    = pathinfo($imgPath);
        	
    	$imgSize = @getimagesize ($img);
    	if (!is_array($imgSize)){
    		return $img;
    	}
    	
    	if($imgSize[0] < (int)$option->width) {
    		return $img;
    	}
            	
    	// Resize path
    	$path = JPATH_ROOT."/cache/jv/resized/".md5($option->width.$info['filename']).".{$info['extension']}";
    
    	if(!is_dir(dirname($path))){
    		JFolder::create(dirname($path));
    	}
    
    	if(!is_file($path)){
    		// Resize
    		$thumb = new GdThumb($img, array('jpegQuality' => isset($option->quality) ? $option->quality : 100));
    		$thumb->adaptiveResize($option->width, $option->height);
    		$thumb->save($path, $info['extension']);
    	}
    
    	return $path;
    }

    public function toURL($path) {
    	$path = str_replace(JPATH_ROOT.DIRECTORY_SEPARATOR, '', str_replace('/', DIRECTORY_SEPARATOR, $path));
    	$url = str_replace(DIRECTORY_SEPARATOR, '/', $path);
    
    	return JURI::root(true) .'/'. $url;
    }
    
    public function render($data){
		$option = $data->get('options');     
		$images = $data->get('images');    
		
		if(is_array($images)){
			foreach ($images as &$img){
				$img->thumbnail = $this->toURL($this->resize($img->img, $option));
			}
		}
       
		$path = JPATH_THEMES.'/'.JFactory::getApplication()->getTemplate().'/html/plg_system_jvgallery/themes/'.$data->get('options.theme').'/gallery.php';        
        if(!is_file($path)){
        	$path = dirname(__FILE__).'/jvgallery/themes/'.$data->get('options.theme').'/gallery.php';
        }

        $doc = JFactory::getDocument();
        $hasJQuery = false;

        foreach ($doc->_scripts as $key => $val) {
           if(preg_match("#jquery#", strtolower($key))){
                $hasJQuery = true;
           }
        }

        if(!is_file($path)){
        	return;
        }
        
        ob_start();
            require $path;
            $html = ob_get_contents();
        ob_clean();
        
       return $html;
    }
       
    public function connector(){
    	$dir = $_POST['dir'];
    	 
    	// Filter
    	$filter = '\.png$|\.gif$|\.jpg$|\.bmp$|\.ico$|\.jpeg$|\.psd$|\.eps$';
    
    	// Get all files
    	$files   = JFolder::files(JPATH_ROOT."/{$dir}", $filter);
    	 
    	// Get all sub folders
    	$folders = JFolder::folders(JPATH_ROOT."/{$dir}", '.');
    	 
    	$html = array();
    	$html[] = '<ul class="jqueryFileTree" style="display: none;">';
    	 
    	if(is_array($folders))
    		foreach ($folders as $folder) {
    		$html[] = '<li class="directory collapsed">';;
    		$html[] = "<a href='#' rel='{$dir}{$folder}/'>$folder</a>";
    		$html[] = '</li>';
    	}
    	 
    	if(is_array($files))
    		foreach ($files as $file) {
    		$ext = preg_replace('/^.*\./', '', $file);
    		$html[] = '<li class="file ext_'.$ext.'">';
    		$html[] = "<a href='#' rel='{$dir}{$file}'>$file</a>";
    		$html[] = '</li>';
    	}
    	 
    	$html[] = '</ul>';
    
    	echo implode($html);
    
    }
    public function html(){
    	$lang = JFactory::getLanguage();
    	$lang->load('plg_system_jvgallery', JPATH_ADMINISTRATOR);
    	$dir = JRequest::getVar('dir', 'images/');
    	$url = JURI::root(true);
    	$themes = JFolder::folders(dirname(__FILE__).'/jvgallery/themes');?>
        	<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
        	<html>
    	    	<head>
    	    		<meta http-equiv="content-type" content="text/html; charset=utf-8" />
    	    		<link rel="stylesheet" href="<?php echo JURI::root(true)?>/plugins/system/jvgallery/jvgallery/admin/css/gallery.css" />
    	    		<link rel="stylesheet" href="<?php echo JURI::root(true)?>/plugins/system/jvgallery/jvgallery/admin/jqueryFileTree.css" />
    		    	<script type="text/javascript" src="<?php echo JURI::root(true)?>/plugins/system/jvgallery/jvgallery/admin/js/jquery.min.js"></script>
    		    	<script type="text/javascript" src="<?php echo JURI::root(true)?>/plugins/system/jvgallery/jvgallery/admin/js/jqueryFileTree.js"></script>
    		    	<script src="//ajax.googleapis.com/ajax/libs/jqueryui/1.8.23/jquery-ui.min.js"></script>
    		    	<script type="text/javascript">
    		    	jQuery(function($){
    			    	var url  		= '<?php echo $url; ?>/',
    			    		items 		= $('#items').sortable(),
    			    		filemanager = $('#filemanager'),
    			    		datas= imgs = []
    		    		;			    	 
    			    	
    			    	filemanager.fileTree({ root: '<?php echo $dir;?>',  script: 'index.php?connector=1' }, function(el) {
    		    			if(el.is('.active')){
    		    		    	el.removeClass('active');
    		    		    	el.data().refer.remove();
    			    		}else{
    			    			el.addClass('active');
    			    			el.data().refer =$('<li/>', {'class': 'clearfix'})
    			    				.append($('<label/>').append($('<img/>', {src: url+el.attr('rel'), rel: el.attr('rel'), 'class':'image'})))
    			    				.append($('<input/>', {type: 'text',name: 'title', 'placeholder': 'Enter title...'}).keyup(function(){items.trigger('dataChange')}))
    			    				.append($('<textarea/>', {name: 'desc', 'placeholder': 'Enter description...'}).keyup(function(){items.trigger('dataChange')}))
    			    				.append($('<span/>', { 'class': 'close','text':'x'}).click(function(){
    			    					el.trigger('click');
    				    			}));
    		    				
    			    			items.append(el.data().refer);
    			    			el.data().refer.data().refer = el;
    			    		}	
    			    		items.trigger('dataChange', el);
    		    			
    	    		    });	
    	    		    
    		    		items.bind('dataChange', function(img){
    		    			datas = [];
    		    			imgs  = [];
    		    			items.children().map(function(index, el){
    			    			var data = {};
    			    			
    			    			data.img   = $(el).find('img').eq(0).attr('rel');
    			    			data.title = $(el).find('input').eq(0).val();
    			    			data.desc  = $(el).find('textarea').eq(0).val();
    
    			    			datas.push(data);
    			    			imgs.push($(el).find('img').eq(0).attr('rel'));	
    			    		});
    		    			
    			    	});
    			    	
    		    		filemanager.bind('ajaxSuccess', function(data){		    			
    		    			filemanager.find('li.file a').each(function(index, el){
    			    			var rel = $(this).attr('rel');
    			    			
    			    			if(jQuery.inArray(rel, imgs) >= 0){
    			    				$(el).addClass('active');
    				    		}			    			
    			    		});
    						
    			    	});
    
    	    		    $('#btn_insert').click(function(){
    		    		    var insertData = {};
    		    		    insertData.images  = datas;
    		    		    insertData.options = {};
    		    		    
    		    		    $('.fields select, .fields input').each(function(){
    			    		    var name = $(this).attr('name');
    			    		    
    			    		    insertData.options[name] = $(this).val();
    		    		    });
    
    						parent.JVGalleryInsert(JSON.stringify(insertData))
    		    		});
    
    	    		    $('#btn_cancel').click(function(){
    	    		    	parent.JVGalleryCancel()
    		    		});
    				});	
    		    	</script>		
    	    	</head>
    	    	<body>
    	    		<fieldset class="jvgallery">
    	    			<div id="allitems">
    		    			<ul id="items"></ul>
    		    		</div>
    		    		<div id="filetree">
    		    			<div id="filemanager"></div>
    		    		</div>
    		    		<ul class="fields">
    		    			<li>
    		    				<label for="theme"><?php echo JText::_('JVGALLERY_PARAM_CHOOSE_THEME')?></label>
    			    			<select id="theme" name="theme">
    			    			<?php if(is_array($themes)){    		
						    			foreach ($themes as $theme) :?>
						    			<option value="<?php echo $theme; ?>" selected="selected"><?php echo ucfirst($theme); ?></option>        
						    	<?php 	endforeach;}?>      
    							</select>
    		    			</li>
    		    			<li>
    		    				<label for="lightbox"><?php echo JText::_('JVGALLERY_PARAM_LIGHTBOX')?></label>
    			    			<select id="lightbox" name="lightbox">
    			    				<option value="">-- Choose ligthbox --</option>  
    					            <option value="slimbox">Slimbox</option>  
    					            <option value="fancybox">FancyBox</option> 
    							</select>
    		    			</li>
    		    			<li>
    		    				<label for="showtitle"><?php echo JText::_('JVGALLERY_PARAM_SHOW_TITLE')?></label>
        						<select id="showtitle" name="showtitle">
    					            <option value="1">Show</option>  
    					            <option value="0">Hide</option> 
    							</select>
    		    			</li>
    		    			<li>
    		    				<label for="showdesc"><?php echo JText::_('JVGALLERY_PARAM_SHOW_DESC')?></label>
        						<select id="showdesc" name="showdesc">
    					            <option value="1">Show</option>  
    					            <option value="0">Hide</option> 	
    							</select>
    		    			</li>
    		    			<li>
    		    				<label for="width"><?php echo JText::_('JVGALLERY_PARAM_WIDTH')?></label>
        						<input id="width" name="width" type="text"  value="100"/>
    		    			</li>
    		    			<li>
    		    				<label for="height"><?php echo JText::_('JVGALLERY_PARAM_HEIGHT')?></label>
    		    				<input id="height" name="height" type="text" value="100"/>
    		    			</li>
    		    			<li>
    		    				<label for="gutter"><?php echo JText::_('JVGALLERY_PARAM_GUTTER')?></label>
    		    				<input id="gutter" name="gutter" type="text" value="10"/>
    		    			</li>
    		    		</ul>			        
    	    		</fieldset>
    	    		<br />
    	    		<button type="submit" id="btn_insert" class="button">Insert</button>
    			    <button type="button" id="btn_cancel" class="button">Cancel</button>
    	    	</body>
        	</html>    	
        	<?php 
        }
            
}