<?php
/**
 # plg_system_jvgallery - JV Gallery
 # @version		2.5.*
 # ------------------------------------------------------------------------
 # author    Open Source Code Solutions Co
 # copyright Copyright (C) 2011 joomlavi.com. All Rights Reserved.
 # @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL or later.
 # Websites: http://www.joomlavi.com
 # Technical Support:  http://www.joomlavi.com/my-tickets.html
-------------------------------------------------------------------------*/

// No direct access to this file
defined('_JEXEC') or die('Restricted access');
$asset = $this->toUrl(dirname(dirname(dirname(__FILE__))).'/assets');
$doc = JFactory::getDocument();
$doc->addStyleSheet($asset.'/css/default.css');
$doc->addStyleSheet($this->toUrl(dirname(__FILE__).'/css/template.css'));
if(!$hasJQuery){
	$doc->addScript($asset.'/js/jquery.min.js');	
}
$doc->addScript($asset.'/js/jquery.masonry.min.js');
$doc->addScript($asset.'/js/gallery.js');

$a = new stdClass();
if(isset($option->lightbox)){
	switch($option->lightbox){
		case 'slimbox':
			$doc->addScript($asset.'/lightboxs/slimbox/js/slimbox2.js');
			$doc->addStyleSheet($asset.'/lightboxs/slimbox/css/slimbox.css');
			$a->class = 'zoom';
			$a->rel = 'lightbox-atomium';
			break;
			
		case 'fancybox':
			$doc->addScript($asset.'/lightboxs/fancybox/jquery.mousewheel-3.0.6.pack.js');
			$doc->addScript($asset.'/lightboxs/fancybox/jquery.fancybox.pack.js');
			$doc->addScript($asset.'/lightboxs/fancybox/helpers/jquery.fancybox-buttons.js');
			
			$doc->addStyleSheet($asset.'/lightboxs/fancybox/jquery.fancybox.css');
			$doc->addStyleSheet($asset.'/lightboxs/fancybox/helpers/jquery.fancybox-buttons.css');
			$a->class = 'fancybox-button zoom';
			$a->rel = 'fancybox-button';			
			
			$doc->addScriptDeclaration("
				jQuery(function($){
					$('.fancybox-button').fancybox({
						prevEffect		: 'fade',
						nextEffect		: 'fade',
						closeBtn		: false,
						openEffect	: 'elastic',
	    				closeEffect	: 'elastic',
					
						helpers		: {
							title	: { type : 'inside' },
							buttons	: {}
						}
					});
				});			
			");
			
			break;
		default:
			$a->class = 'zoom';
			$a->rel = 'lightbox-none';
		break;
	}
}?>
<?php if(is_array($images)):?>
<div class="jvgallery jvgallery-masonry" data-width="<?php echo ($option->width + $option->gutter); ?>">
	<ul class="gallery-item style6">
        <?php foreach($images as $image): ?>        
        <li class="box" style="width:<?php echo $option->width; ?>px">
            <div>
                <div class="item">
                <img src="<?php echo $image->thumbnail; ?>" title="<?php echo $image->title; ?>"  alt="<?php echo $image->desc; ?>" />
                <a href="<?php echo $image->img; ?>" rel="<?php echo $a->rel; ?>" title="<?php echo $image->title; ?>" class="<?php echo $a->class; ?>">
                	<span></span>	
                </a>
                </div>
                <?php if($option->showtitle || $option->showdesc):?>
                <div class="jv-caption">
                    <div>
                        <?php if ($image->title && $option->showtitle):?>
                            <h3 class="gallery-title"><?php echo $image->title; ?></h3>
                        <?php endif;?>
                        <?php if ($image->desc && $option->showdesc):?>
                            <p><?php echo $image->desc ?></p>
                         <?php endif;?>
                    </div>
                </div>
                <?php endif;?>
            </div>
        </li>
        <?php endforeach;?>
   </ul>
</div>
<?php endif; 