/*
 * jQuery UI Accordion 1.8.17
 *
 * Copyright 2011, AUTHORS.txt (http://jqueryui.com/about)
 * Dual licensed under the MIT or GPL Version 2 licenses.
 * http://jquery.org/license
 *
 * http://docs.jquery.com/UI/NumericBox
 *
 * Depends:
 *    jquery.ui.core.js
 *    jquery.ui.widget.js
 *    jquery.ui.button.js
 *    jquery.ui.autocomplete.js
 *    jquery.ui.slider.js
 */
(function($){
    $.widget( "ui.numericBox", {
            _create: function() {
                var
                    options = this.options = $.extend({min: 0, max: 100, step: 1},this.options),
                    lastVal = options.value,
                    input = this.element.focusout(function(){
                        input.val(getVal(input.val()));
                    }).bind(options.events),
                    inputPanel = $('<span>',{'class': 'ui-numericbox-input ui-widget ui-widget-content ui-corner-left'}),
                    getVal = function(val){
                        val = val - val % options.step;
                        val = val > options.max ? options.max : (val < options.min? options.min : val);
                        lastVal == val || input.trigger('change');
                        lastVal = val;
                        return val;
                    },
                    btnUp = $('<span>',{'class': 'ui-numericbox-up'})
                        .button({icons:{primary: 'ui-icon-triangle-1-n'}})
                        .removeClass('ui-corner-all')
                        .addClass('ui-corner-top')
                        .click(function(){
                            input.val(options.value = getVal(parseFloat(input.val()) + options.step));
                            return false;
                        }),
                    btnDown = $('<span>',{'class': 'ui-numericbox-down'})
                        .button({icons:{primary: 'ui-icon-triangle-1-s'}})
                        .removeClass('ui-corner-all')
                        .addClass('ui-corner-bottom')
                        .click(function(){
                            input.val(options.value = getVal(parseFloat(input.val()) - options.step));
                            return false;
                        }),
                    btns = $('<span>',{'class': 'ui-numericbox-controls'}).append(btnUp,btnDown),
                    wrapper = this.wrapper = $( "<span>",{'class': 'ui-numericbox'} )
                        .insertAfter(input).append(inputPanel.append(input),btns)
                ;
                input.val(options.value);
            },
            destroy: function() {
                this.wrapper.after(this.element).remove();
                $.Widget.prototype.destroy.call( this );
            }
        });
})(jQuery)    